unit ufmMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, Grids, DBGrids, FIBDataSet, pFIBDataSet, FIBDatabase, pFIBDatabase, StdCtrls,
  uCryptHelper, ufmLoginDialog;

type
  TfmMain = class(TForm)
    btActivate: TButton;
    pFIBDatabase1: TpFIBDatabase;
    pFIBTransaction1: TpFIBTransaction;
    pFIBDataSet1: TpFIBDataSet;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    btQuit: TButton;
    procedure pFIBDatabase1BeforeConnect(Database: TFIBDatabase; LoginParams: TStrings; var DoConnect: Boolean);
    procedure btActivateClick(Sender: TObject);
    procedure btQuitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    CH                  :TCryptHelper;
    KeysArray           :TCryptKeysArray;
    FDCP                :TDBConParamRec;
    MRUDBList:TStrings;
  public
    { Public declarations }
  end;

var
  fmMain: TfmMain;

implementation

{$R *.dfm}

procedure TfmMain.FormCreate(Sender: TObject);
begin
  FDCP.SetDefaults;
  CH:=TCryptHelper.Create(FDCP.LibraryName);
  MRUDBList:=TStringList.Create;
end;

procedure TfmMain.FormDestroy(Sender: TObject);
begin
  if Assigned(CH) then FreeAndNil(CH);
  if Assigned(MRUDBList) then FreeAndNil(MRUDBList);
end;



procedure TfmMain.btQuitClick(Sender: TObject);
begin
  if pFIBDatabase1.Connected then begin
    pFIBDatabase1.Connected:=False;
  end;
  Exit;
end;


procedure TfmMain.pFIBDatabase1BeforeConnect(Database: TFIBDatabase; LoginParams: TStrings; var DoConnect: Boolean);
begin
  SetLength(KeysArray, 3);
  KeysArray[0].Name:='Red';
  KeysArray[0].pValue := @keyRed;

  KeysArray[1].Name:='Green';
  KeysArray[1].pValue := @keyGreen;

  KeysArray[2].Name:='Blue';
  KeysArray[2].pValue := @keyBlue;

  CH.GrantAccess(KeysArray, FDCP.LibraryName);
end;




procedure TfmMain.btActivateClick(Sender: TObject);
var
  LD: TfmLoginDialog;
  mres:Integer;
begin
  if pFIBDatabase1.Connected then begin
    pFIBDatabase1.Connected:=False;
  end;

  LD := TfmLoginDialog.Create(fmMain);
  try
    LD.ApplyOldDCP(FDCP, MRUDBList);
    mres := LD.ShowModal;
    if mres <> mrOK then Exit;
    FDCP := LD.GetConnectionParam;
  finally
    FreeAndNil(LD);
  end;
  fmMain.Caption := FDCP.GetFullDBName;


  pFIBDatabase1.LibraryName := FDCP.LibraryName;
  pFIBDatabase1.ConnectParams.UserName := FDCP.UserName;
  pFIBDatabase1.ConnectParams.Password := FDCP.Password;
  pFIBDatabase1.ConnectParams.RoleName := FDCP.Password;
  pFIBDatabase1.ConnectParams.CharSet  := FDCP.Charset;
  pFIBDatabase1.SQLDialect := FDCP.SQLDialect;
  pFIBDatabase1.DBName := FDCP.GetFullDBName;



  pFIBDatabase1.Connected:=True;
  pFIBDataSet1.Active:=True;
end;



end.
