#include <dlfcn.h>
#include <phpcpp.h>
#include <iostream>

typedef void* HINSTANCE;

/**
 *  tell the compiler that the get_module is a pure C function
 */
extern "C" {
    HINSTANCE FBCryptLibPtr;

    Php::Value cryptinit(Php::Parameters &params) {
        Php::out << "<br>First Test Output!!!" << std::endl;
        const char * pszkeyName  = params[0];
        const char * pszKeyValue = params[1];
        size_t    keyValueLength = params[1].size();
        Php::Value fbcrypt  = params[2];
        Php::Value fbclient = params[3];

        Php::out << "<br>keyName "  << pszkeyName << std::endl;
        Php::out << "<br>keyValue " << pszKeyValue << std::endl;
        Php::out << "<br>fbcrypt "  << fbcrypt << std::endl;
        Php::out << "<br>fbclient " << fbclient << std::endl;
        Php::out << "<br>" << std::endl;

        FBCryptLibPtr = dlopen (fbcrypt, RTLD_NOW); //"libfbcrypt.so"
	    if (!FBCryptLibPtr) {
            Php::error << "Can't load fbcrypt library!" << std::flush;
            //Php::error terminate execution inside itself
		    //return FAILURE;
	    }
        //on unload do: dlclose(); ?


        //todo: check if argument not empty and has correct sizes ?



	    //extern "C" int fbcrypt_init(const char* clientPathName);
	    int (*ptr_fbcrypt_init) (const char* clientPathName);
	    ptr_fbcrypt_init = (int (*)(const char *)) dlsym (FBCryptLibPtr, "fbcrypt_init");

	    if (!ptr_fbcrypt_init){
            Php::error << "can't find 'fbcrypt_init(..)' inside FBCRYPT library" << std::flush;
	    }
	    if (ptr_fbcrypt_init (fbclient) < 0) {
            Php::error << "fbcrypt_init falied" << std::flush;
	    }


	    //extern "C" int fbcrypt_key(const char* name, const unsigned char* data, unsigned dl);
	    int (*ptr_fbcrypt_key) (const char* name, const unsigned char* data, unsigned dl);
	    ptr_fbcrypt_key = (int (*)(const char *, const unsigned char *, unsigned)) dlsym (FBCryptLibPtr, "fbcrypt_key");
	    if (!ptr_fbcrypt_key) {
		    Php::error << "can't find 'fbcrypt_key(..)' inside FBCRYPT library" << std::flush;
	    }

	    //if ( ptr_fbcrypt_key("Zero", Zero, sizeof(Zero)) < 0) {
	    if (ptr_fbcrypt_key (pszkeyName, (const unsigned char *)pszKeyValue, keyValueLength) < 0) { //(const unsigned char *) 
            Php::error << "Can't set key " << pszkeyName << " via fbcrypt_key(..)" << std::flush;
	    }


	    //extern "C" int fbcrypt_callback(void* provider);
	    int (*ptr_fbcrypt_callback) (void* provider);
	    ptr_fbcrypt_callback = (int (*)(void *provider)) dlsym (FBCryptLibPtr, "fbcrypt_callback");
	    if (!ptr_fbcrypt_callback) {
		    Php::error << "can't find 'fbcrypt_callback(..)' inside FBCRYPT library" << std::flush;
	    }
	    if (ptr_fbcrypt_callback (0) < 0) {
		    Php::error << "fbcrypt_callback falied" << std::flush;
	    }


        return (long)keyValueLength; //.c_str();
    }


    /**
     *  Function that is called by PHP right after the PHP process
     *  has started, and that returns an address of an internal PHP
     *  strucure with all the details and features of your extension
     *
     *  @return void*   a pointer to an address that is understood by PHP
     */
    PHPCPP_EXPORT void *get_module() 
    {
        // static(!) Php::Extension object that should stay in memory
        // for the entire duration of the process (that's why it's static)
        static Php::Extension extension("cryptloader", "1.0");
        
        // @todo    add your own functions, classes, namespaces to the extension
        extension.add<cryptinit>("cryptinit",  {
            Php::ByVal("KeyName", Php::Type::String),
            Php::ByVal("KeyValue", Php::Type::String),
            Php::ByVal("fbcryptlib", Php::Type::String),
            Php::ByVal("fbclientlib", Php::Type::String)
        });
        
        // return the extension
        return extension;
    }

}
